
% ========================================================================

\ifx\pdfoutput\undefined % We're not running pdftex
\documentclass[11pt,a4paper]{report}
\else
\documentclass[11pt,a4paper,pdftex]{report}
\fi

\usepackage{epsf}
\usepackage{latexsym}
\usepackage{a4}
\usepackage{version}   % for comment
\usepackage[dvips]{graphicx}

\ifx\pdfoutput\undefined % We *are* running pdftex
\else
% The hyperref package must be the last package called.
\usepackage{color}
\usepackage[colorlinks,hyperindex]{hyperref}
\usepackage{times,mathptm}
\usepackage{makeidx, showidx}

\definecolor{links}{rgb}{0.4,0.5,0}
\definecolor{anchors}{rgb}{1,0,0}
\def\AnchorColor{anchors}
\def\LinkColor{links}
\def\pdfBorderAttrs{/Border [0 0 0] } % No border around Links
\fi

\graphicspath{{./images/}}
\pagestyle{headings}
\frenchspacing


% ============================================================================

\title{Testing of Java Bytecode Transformations}
\author{Horacio S. Gagliano}

\makeindex

\begin{document}
\maketitle
\clearpage

% ============================================================================
\begin{abstract}
In the context of checking Java programs, JNuke, a framework which analyzes Java
bytecode was developed. To achieve a higher flexibility, it transforms the
Java bytecode into a simpler, but functionally equivalent form. The framework
is implemented in C and supports two intermediary representations for 
representing Java bytecode: the \emph{Abstract Bytecode} and the \emph{Register Based 
Bytecode}. This report describes the motivation for each representation, and 
the salient points in translating one representation to another. \\
The question of how to guarantee the correctness of such transformations comes
up immediately, as the quality expectations for a program analyzer are very 
high. The goal of this work was to partially verify this correctness. To 
achieve this, an interpreter for the \emph{Register Based Instruction Set} was 
designed. During the second phase of this project 55 test cases were done. The
experimental results are encouraging and show transformation correctness, 
although a perfect emulation of the Java Virtual Machine could not be achieved.
\end{abstract}
\clearpage

\setcounter{page}{0}
\renewcommand{\thepage}{}

\chapter*{Acknowledgments}
This Diploma Work would not have been possible without the guidance and tutelage
of Cyrille Artho. It was he who taught me this field and gave me invaluable
guidance at every stage of the work - from the initial planning to the end.\\
More thanks to Prof. Armin Biere of the Swiss Federal Institute of Technology
for introducing me in Model Checking and for taking the time to proofread this report
meticulously and having the patience for revising all concepts until they were right.
\clearpage

\renewcommand{\thepage}{\roman{page}}

\tableofcontents
\clearpage

\listoffigures
\clearpage

\listoftables
\clearpage


% ========================================================================
\setcounter{page}{1}
\renewcommand{\thepage}{\arabic{page}}

\chapter{Introduction}
\input{introd.tex}

\clearpage
\chapter{Interpreter design}
\input{design.tex}

\clearpage
\chapter{Implementation}
\input{impl.tex}

\clearpage
\chapter{Results}
\input{res.tex}

\clearpage
\chapter{Future Work}
\input{fwork.tex}

\clearpage
\chapter{Conclusions}
\input{concl.tex}

% ========================================================================
% appendix
\clearpage
\appendix
\chapter{The Register Based Instruction Set}
\input{appA.tex}

\clearpage
\chapter{Code examples}
\input{appB.tex}

\clearpage
\chapter{Testing transformations}
\input{appC.tex}

\clearpage
\chapter{List of test cases}
\input{appD.tex}

% ============================================================================

\clearpage
\addcontentsline{toc}{chapter}{Bibliography}
\input{biblio.tex}

% =========================================================

\clearpage
\addcontentsline{toc}{chapter}{Index}
\input{interpr.ind}

%\printindex
\end{document}


